ivatar/ivataraccount/urls.py
# -*- coding: utf-8 -*-
"""
URLs for ivatar.ivataraccount
"""
from django.urls import path, re_path

from django.contrib.auth.views import LogoutView
from django.contrib.auth.views import (
    PasswordResetDoneView,
    PasswordResetConfirmView,
    PasswordResetCompleteView,
)
from django.contrib.auth.views import PasswordChangeView, PasswordChangeDoneView

from .views import ProfileView, PasswordResetView
from .views import CreateView, PasswordSetView, AddEmailView
from .views import RemoveUnconfirmedEmailView, ConfirmEmailView
from .views import RemoveConfirmedEmailView, AssignPhotoEmailView
from .views import RemoveUnconfirmedOpenIDView, RemoveConfirmedOpenIDView
from .views import ImportPhotoView, RawImageView, DeletePhotoView
from .views import UploadPhotoView, AssignPhotoOpenIDView
from .views import AddOpenIDView, RedirectOpenIDView, ConfirmOpenIDView
from .views import CropPhotoView
from .views import UserPreferenceView, UploadLibravatarExportView
from .views import ResendConfirmationMailView
from .views import IvatarLoginView
from .views import DeleteAccountView
from .views import ExportView

# Define URL patterns, self documenting
# To see the fancy, colorful evaluation of these use:
# ./manager show_urls
urlpatterns = [  # pylint: disable=invalid-name
    path("new/", CreateView.as_view(), name="new_account"),
    path("login/", IvatarLoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(next_page="/"), name="logout"),
    path(
        "password_change/",
        PasswordChangeView.as_view(template_name="password_change.html"),
        name="password_change",
    ),
    path(
        "password_change/done/",
        PasswordChangeDoneView.as_view(template_name="password_change_done.html"),
        name="password_change_done",
    ),
    path(
        "password_reset/",
        PasswordResetView.as_view(template_name="password_reset.html"),
        name="password_reset",
    ),
    path(
        "password_reset/done/",
        PasswordResetDoneView.as_view(template_name="password_reset_submitted.html"),
        name="password_reset_done",
    ),
    path(
        "reset/<uidb64>/<token>/",
        PasswordResetConfirmView.as_view(template_name="password_change.html"),
        name="password_reset_confirm",
    ),
    path(
        "reset/done/",
        PasswordResetCompleteView.as_view(template_name="password_change_done.html"),
        name="password_reset_complete",
    ),
    path(
        "export/",
        ExportView.as_view(),
        name="export",
    ),
    path("delete/", DeleteAccountView.as_view(), name="delete"),
    path("profile/", ProfileView.as_view(), name="profile"),
    re_path(
        "profile/(?P<profile_username>.+)",
        ProfileView.as_view(),
        name="profile_with_profile_username",
    ),
    path("add_email/", AddEmailView.as_view(), name="add_email"),
    path("add_openid/", AddOpenIDView.as_view(), name="add_openid"),
    path("upload_photo/", UploadPhotoView.as_view(), name="upload_photo"),
    path("password_set/", PasswordSetView.as_view(), name="password_set"),
    re_path(
        r"remove_unconfirmed_openid/(?P<openid_id>\d+)",
        RemoveUnconfirmedOpenIDView.as_view(),
        name="remove_unconfirmed_openid",
    ),
    re_path(
        r"remove_confirmed_openid/(?P<openid_id>\d+)",
        RemoveConfirmedOpenIDView.as_view(),
        name="remove_confirmed_openid",
    ),
    re_path(
        r"openid_redirection/(?P<openid_id>\d+)",
        RedirectOpenIDView.as_view(),
        name="openid_redirection",
    ),
    re_path(
        r"confirm_openid/(?P<openid_id>\w+)",
        ConfirmOpenIDView.as_view(),
        name="confirm_openid",
    ),
    re_path(
        r"confirm_email/(?P<verification_key>\w+)",
        ConfirmEmailView.as_view(),
        name="confirm_email",
    ),
    re_path(
        r"remove_unconfirmed_email/(?P<email_id>\d+)",
        RemoveUnconfirmedEmailView.as_view(),
        name="remove_unconfirmed_email",
    ),
    re_path(
        r"remove_confirmed_email/(?P<email_id>\d+)",
        RemoveConfirmedEmailView.as_view(),
        name="remove_confirmed_email",
    ),
    re_path(
        r"assign_photo_email/(?P<email_id>\d+)",
        AssignPhotoEmailView.as_view(),
        name="assign_photo_email",
    ),
    re_path(
        r"assign_photo_openid/(?P<openid_id>\d+)",
        AssignPhotoOpenIDView.as_view(),
        name="assign_photo_openid",
    ),
    re_path(r"import_photo/$", ImportPhotoView.as_view(), name="import_photo"),
    re_path(
        r"import_photo/(?P<email_addr>[\w.+-]+@[\w.]+.[\w.]+)",
        ImportPhotoView.as_view(),
        name="import_photo",
    ),
    re_path(
        r"import_photo/(?P<email_id>\d+)",
        ImportPhotoView.as_view(),
        name="import_photo",
    ),
    re_path(
        r"delete_photo/(?P<pk>\d+)", DeletePhotoView.as_view(), name="delete_photo"
    ),
    re_path(r"raw_image/(?P<pk>\d+)", RawImageView.as_view(), name="raw_image"),
    re_path(r"crop_photo/(?P<pk>\d+)", CropPhotoView.as_view(), name="crop_photo"),
    re_path(r"pref/$", UserPreferenceView.as_view(), name="user_preference"),
    re_path(
        r"upload_export/$", UploadLibravatarExportView.as_view(), name="upload_export"
    ),
    re_path(
        r"upload_export/(?P<save>save)$",
        UploadLibravatarExportView.as_view(),
        name="upload_export",
    ),
    re_path(
        r"resend_confirmation_mail/(?P<email_id>\d+)",
        ResendConfirmationMailView.as_view(),
        name="resend_confirmation_mail",
    ),
]

ivatar/urls.py
# -*- coding: utf-8 -*-
"""
ivatar URL configuration
"""
from django.contrib import admin
from django.urls import path, include, re_path
from django.conf.urls.static import static
from django.views.generic import TemplateView, RedirectView
from ivatar import settings
from .views import AvatarImageView, GravatarProxyView, StatsView

urlpatterns = [  # pylint: disable=invalid-name
    path("admin/", admin.site.urls),
    path("i18n/", include("django.conf.urls.i18n")),
    path("openid/", include("django_openid_auth.urls")),
    path("tools/", include("ivatar.tools.urls")),
    re_path(
        r"avatar/(?P<digest>\w{64})", AvatarImageView.as_view(), name="avatar_view"
    ),
    re_path(
        r"avatar/(?P<digest>\w{32})", AvatarImageView.as_view(), name="avatar_view"
    ),
    re_path(r"avatar/$", AvatarImageView.as_view(), name="avatar_view"),
    re_path(
        r"avatar/(?P<digest>\w*)",
        RedirectView.as_view(url="/static/img/deadbeef.png"),
        name="invalid_hash",
    ),
    re_path(
        r"gravatarproxy/(?P<digest>\w*)",
        GravatarProxyView.as_view(),
        name="gravatarproxy",
    ),
    path(
        "description/",
        TemplateView.as_view(template_name="description.html"),
        name="description",
    ),
    # The following two are TODO TODO TODO TODO TODO
    path(
        "run_your_own/",
        TemplateView.as_view(template_name="run_your_own.html"),
        name="run_your_own",
    ),
    path(
        "features/",
        TemplateView.as_view(template_name="features.html"),
        name="features",
    ),
    path(
        "security/",
        TemplateView.as_view(template_name="security.html"),
        name="security",
    ),
    path(
        "privacy/", TemplateView.as_view(template_name="privacy.html"), name="privacy"
    ),
    path(
        "contact/", TemplateView.as_view(template_name="contact.html"), name="contact"
    ),
    path("talk_to_us/", RedirectView.as_view(url="/contact"), name="talk_to_us"),
    path("stats/", StatsView.as_view(), name="stats"),
]

MAINTENANCE = False
try:
    if settings.MAINTENANCE:
        MAINTENANCE = True
except Exception:  # pylint: disable=bare-except
    pass

if MAINTENANCE:
    urlpatterns.append(
        path("", TemplateView.as_view(template_name="maintenance.html"), name="home")
    )
    urlpatterns.insert(3, path("accounts/", RedirectView.as_view(url="/")))
else:
    urlpatterns.append(
        path("", TemplateView.as_view(template_name="home.html"), name="home")
    )
    urlpatterns.insert(3, path("accounts/", include("ivatar.ivataraccount.urls")))

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

ivatar/ivataraccount/forms.py
# -*- coding: utf-8 -*-
"""
Classes for our ivatar.ivataraccount.forms
"""
from urllib.parse import urlsplit, urlunsplit

from django import forms
from django.utils.translation import gettext_lazy as _

from ipware import get_client_ip

from ivatar import settings
from ivatar.settings import MIN_LENGTH_EMAIL, MAX_LENGTH_EMAIL
from ivatar.settings import MIN_LENGTH_URL, MAX_LENGTH_URL
from .models import UnconfirmedEmail, ConfirmedEmail, Photo
from .models import UnconfirmedOpenId, ConfirmedOpenId
from .models import UserPreference


MAX_NUM_UNCONFIRMED_EMAILS_DEFAULT = 5


class AddEmailForm(forms.Form):
    """
    Form to handle adding email addresses
    """

    email = forms.EmailField(
        label=_("Email"),
        min_length=MIN_LENGTH_EMAIL,
        max_length=MAX_LENGTH_EMAIL,
    )

    def clean_email(self):
        """
        Enforce lowercase email
        """
        # TODO: Domain restriction as in libravatar?
        return self.cleaned_data["email"].lower()

    def save(self, request):
        """
        Save the model, ensuring some safety
        """
        user = request.user
        # Enforce the maximum number of unconfirmed emails a user can have
        num_unconfirmed = user.unconfirmedemail_set.count()

        max_num_unconfirmed_emails = getattr(
            settings, "MAX_NUM_UNCONFIRMED_EMAILS", MAX_NUM_UNCONFIRMED_EMAILS_DEFAULT
        )

        if num_unconfirmed >= max_num_unconfirmed_emails:
            self.add_error(None, _("Too many unconfirmed mail addresses!"))
            return False

        # Check whether or not a confirmation email has been
        # sent by this user already
        if UnconfirmedEmail.objects.filter(  # pylint: disable=no-member
            user=user, email=self.cleaned_data["email"]
        ).exists():
            self.add_error("email", _("Address already added, currently unconfirmed"))
            return False

        # Check whether or not the email is already confirmed (by someone)
        check_mail = ConfirmedEmail.objects.filter(email=self.cleaned_data["email"])
        if check_mail.exists():
            msg = _("Address already confirmed (by someone else)")
            if check_mail.first().user == request.user:
                msg = _("Address already confirmed (by you)")
            self.add_error("email", msg)
            return False

        unconfirmed = UnconfirmedEmail()
        unconfirmed.email = self.cleaned_data["email"]
        unconfirmed.user = user
        unconfirmed.save()
        unconfirmed.send_confirmation_mail(url=request.build_absolute_uri("/")[:-1])
        return True


class UploadPhotoForm(forms.Form):
    """
    Form handling photo upload
    """

    photo = forms.FileField(
        label=_("Photo"),
        error_messages={"required": _("You must choose an image to upload.")},
    )
    not_porn = forms.BooleanField(
        label=_("suitable for all ages (i.e. no offensive content)"),
        required=True,
        error_messages={
            "required": _(
                'We only host "G-rated" images and so this field must be checked.'
            )
        },
    )
    can_distribute = forms.BooleanField(
        label=_("can be freely copied"),
        required=True,
        error_messages={
            "required": _(
                "This field must be checked since we need to be able to distribute photos to third parties."
            )
        },
    )

    @staticmethod
    def save(request, data):
        """
        Save the model and assign it to the current user
        """
        # Link this file to the user's profile
        photo = Photo()
        photo.user = request.user
        photo.ip_address = get_client_ip(request)[0]
        photo.data = data.read()
        photo.save()
        if not photo.pk:
            return None
        return photo


class AddOpenIDForm(forms.Form):
    """
    Form to handle adding OpenID
    """

    openid = forms.URLField(
        label=_("OpenID"),
        min_length=MIN_LENGTH_URL,
        max_length=MAX_LENGTH_URL,
        initial="http://",
    )

    def clean_openid(self):
        """
        Enforce restrictions
        """
        # Lowercase hostname port of the URL
        url = urlsplit(self.cleaned_data["openid"])
        data = urlunsplit(
            (url.scheme.lower(), url.netloc.lower(), url.path, url.query, url.fragment)
        )

        # TODO: Domain restriction as in libravatar?
        return data

    def save(self, user):
        """
        Save the model, ensuring some safety
        """
        if ConfirmedOpenId.objects.filter(  # pylint: disable=no-member
            openid=self.cleaned_data["openid"]
        ).exists():
            self.add_error("openid", _("OpenID already added and confirmed!"))
            return False

        if UnconfirmedOpenId.objects.filter(  # pylint: disable=no-member
            openid=self.cleaned_data["openid"]
        ).exists():
            self.add_error("openid", _("OpenID already added, but not confirmed yet!"))
            return False

        unconfirmed = UnconfirmedOpenId()
        unconfirmed.openid = self.cleaned_data["openid"]
        unconfirmed.user = user
        unconfirmed.save()

        return unconfirmed.pk


class UpdatePreferenceForm(forms.ModelForm):
    """
    Form for updating user preferences
    """

    class Meta:  # pylint: disable=too-few-public-methods
        """
        Meta class for UpdatePreferenceForm
        """

        model = UserPreference
        fields = ["theme"]


class UploadLibravatarExportForm(forms.Form):
    """
    Form handling libravatar user export upload
    """

    export_file = forms.FileField(
        label=_("Export file"),
        error_messages={"required": _("You must choose an export file to upload.")},
    )
    not_porn = forms.BooleanField(
        label=_("suitable for all ages (i.e. no offensive content)"),
        required=True,
        error_messages={
            "required": _(
                'We only host "G-rated" images and so this field must be checked.'
            )
        },
    )
    can_distribute = forms.BooleanField(
        label=_("can be freely copied"),
        required=True,
        error_messages={
            "required": _(
                "This field must be checked since we need to be able to\
              distribute photos to third parties."
            )
        },
    )


class DeleteAccountForm(forms.Form):
    password = forms.CharField(
        label=_("Password"), required=False, widget=forms.PasswordInput()
    )

ivatar/ivataraccount/templates/add_email.html
{% extends 'base.html' %}
{% load i18n %}

{% block title %}{% trans 'Add a new email address' %}{% endblock title %}

{% block content %}

<h1>{% trans 'Add a new email address' %}</h1>

<p>{% blocktrans %}Otherwise, type your email address in the box below and we will send you an email with a link to click on in order to verify that you own that email address.{% endblocktrans %}</p>

{% if form.errors %}
    {% for error in form.non_field_errors %}
        <div class="alert alert-danger" role="alert">{{ error|escape }}</div>
    {% endfor %}
{% endif %}
{% if form.email.errors %}
<div class="alert alert-danger" role="alert">{{ form.email.errors }}</div>
{% endif %}
<div style="max-width:640px">
<form action="{% url 'add_email' %}" name="addemail" method="post" id="form-addemail">
{% csrf_token %}

<div class="form-group">
<label for="id_email">{% trans 'Email' %}:</label>
<input type="text" name="email" autofocus required class="form-control" id="id_email">
</div>
<button type="submit" class="button">{% trans 'Add' %}</button>

</form>
</div>
<div style="height:40px"></div>
{% endblock content %}

ivatar/ivataraccount/templates/add_openid.html
{% extends 'base.html' %}                                                                                                                      
{% load i18n %}

{% block title %}{% trans 'Add a new OpenID' %}{% endblock title %}

{% block content %}

<h1>{% trans 'Add a new OpenID' %}</h1>

<p>{% trans 'Once you have confirmed this OpenID URL, you will be able to log into your account using that OpenID URL.' %}<br/>
{% trans 'You will be redirected to the authorisation page for the provider. If the process fails, you can remove the ID from this list and try adding it again.' %}</p>
{% if form.openid.errors %}
<div class="alert alert-danger" role="alert">{{ form.openid.errors }}</div>
{% endif %}
<div style="max-width:640px">
<form action="{% url 'add_openid' %}" name="addopenid" method="post">
{% csrf_token %}

<div class="form-group">
<label for="id_openid">{% trans 'OpenID' %}:</label>
<input type="url" name="openid" value="https://" maxlength="255" minlength="11" required id="id_openid" autofocus class="form-control">
</div>
<button type="submit" class="button">{% trans 'Add' %}</button>

</form>
</div>
<div style="height:40px"></div>
{% endblock content %}

ivatar/ivataraccount/templates/assign_photo_openid.html
{% extends 'base.html' %}
{% load i18n %}

{% block title %}{% blocktrans with openid.openid as openid_address %}Choose a photo for {{ openid_address }}{% endblocktrans %}{% endblock title %}

{% block content %}
<style>
.nobutton {
background: none;
color: inherit;
border: none;
padding: 0;
font: inherit;
cursor: pointer;
outline: inherit;
}
</style>
<h1>{% blocktrans with openid.openid as openid_address %}Choose a photo for {{ openid_address }}{% endblocktrans %}</h1>

{% if not user.photo_set.count %}

{% url 'upload_photo' as upload_url %}
<h3>{% blocktrans %}You need to <a href="{{ upload_url }}">upload some photos</a> first!{% endblocktrans %}</h3>

<p><a href="{% url 'profile' %}" class="button">{% trans 'Back to your profile' %}</a></p>

{% else %}

<p>{% trans 'Here are the pictures you have uploaded, click on the one you wish to associate with this openid address:' %}</p>
<div class="row">
{% for photo in user.photo_set.all %}
<form action="{% url 'assign_photo_openid' view.kwargs.openid_id %}" method="post" style="float:left;margin-left:20px">{% csrf_token %}
  <input type="hidden" name="photo_id" value="{{ photo.id }}">
  <button type="submit" name="photo{{ photo.id }}" class="nobutton">
<div class="panel panel-tortin" style="width:132px;margin:0">
  <div class="panel-heading">
    <h3 class="panel-title">{% if openid.photo.id == photo.id %}<i class="fa fa-check"></i>{% endif %} {% trans 'Image' %} {{ forloop.counter }}</h3>
</div>
  <div class="panel-body" style="height:130px">
        <center>
            <img style="max-height:100px;max-width:100px" src="{% url 'raw_image' photo.id %}">
        </center>
</div>
</div>
</button>
  </form>
{% endfor %}
<form action="{% url 'assign_photo_openid' view.kwargs.openid_id %}" method="post" style="float:left;margin-left:20px">{% csrf_token %}
<button type="submit" name="photoNone" class="nobutton">
<div class="panel panel-tortin" style="width:132px;margin:0">
  <div class="panel-heading">
    <h3 class="panel-title">{% if openid.photo.id == photo.id %}<i class="fa fa-check"></i>{% endif %} {% trans 'No image' %}</h3>
</div>
  <div class="panel-body" style="height:130px">
        <center>
            <img style="max-height:100px;max-width:100px" src="/static/img/nobody/100.png">
        </center>
</div>
</div>
</button>
  </form>
</div>
<div style="height:8px"></div>
<a href="{% url 'upload_photo' %}" class="button">{% blocktrans %}upload a new one{% endblocktrans %}</a>

{% endif %}
<div style="height:40px"></div>
{% endblock content %}

ivatar/ivataraccount/templates/choose_libravatar_export.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Choose items to be uploaded' %}{% endblock title %}

{% block content %}
<style>
input[type=checkbox] {display:none}
input[type=checkbox].image + label:before {
font-family: FontAwesome;
display: inline-block;
}
input[type=checkbox].image + label:before {content: "\f096"}
input[type=checkbox].image + label:before {letter-spacing: 5px}
input[type=checkbox].image:checked + label:before {content: "\f046"}
input[type=checkbox].image:checked + label:before {letter-spacing: 3px}
</style>
  <h1>{% trans 'Choose items to be imported' %}</h1>

    <form method="post" action="{% url 'upload_export' 'save' %}">{% csrf_token %}
      {% if emails %}
        <h4>{% trans 'Email addresses we found in the export - existing ones will not be re-added' %}</h4>
        {% for email in emails %}
        <div class="checkbox">
          <input type="checkbox" checked name="email_{{ forloop.counter }}" id="email_{{ forloop.counter }}" value="{{ email.email }}" class="text"><label for="email_{{ forloop.counter }}">{{ email.email }}</label>
          </div>
        {% endfor %}
      {% endif %}
      {% if photos %}
          <h4>{% trans 'Photos we found in the export' %}</h4>
<div class="row">
        {% for photo in photos %}
<div class="panel panel-tortin" style="width:132px;float:left;margin-left:20px">
  <div class="panel-heading">
    <h3 class="panel-title">
        <input type="checkbox" checked name="photo_{{ forloop.counter }}" id="photo_{{ forloop.counter }}" value="{{ photo.data }}" class="image">
<label for="photo_{{ forloop.counter }}">{% trans 'Image' %} {{ forloop.counter }}</label>
</label>
</h3></div>
  <div class="panel-body">
        <center>
            <img style="max-height:100px;max-width:100px" src="data:image/{{ photo.format }};base64,{{ photo.data }}">
        </center>
</div>
</div>
        {% endfor %}
</div>
      {% endif %}
<p>
        <button type="submit" class="button">{% trans 'Upload' %}</button>
</p>
    </form>
<div style="height:40px"></div>
{% endblock content %}

ivatar/ivataraccount/templates/preferences.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Your Preferences' %}{% endblock title %}

{% block content %}
<h1>{% trans 'Account settings' %}</h1>

<label for="id_username">{% trans 'Username' %}:</label>
<input type="text" name="username" class="form-control" id="id_username" disabled value="{{ user.username }}" style="max-width:600px;">
<form action="{% url 'user_preference' %}" method="post">{% csrf_token %}
  <div class="form-group">
    <label for="id_first_name">{% trans 'Firstname' %}:</label>
    <input type="text" name="first_name" class="form-control" id="id_first_name" value="{{ user.first_name }}" style="max-width:600px;">
    <label for="id_last_name">{% trans 'Lastname' %}:</label>
    <input type="text" name="last_name" class="form-control" id="id_last_name" value="{{ user.last_name }}" style="max-width:600px;">

    <label for="id_email">{% trans 'E-mail address' %}:</label>
    <select name="email" class="form-control" id="id_email" style="max-width:600px;">
      <option value="{{ user.email }}" selected>{{ user.email }}</option>
      {% for confirmed_email in user.confirmedemail_set.all %}
        {% if user.email != confirmed_email.email %}
          <option value="{{ confirmed_email.email }}">{{ confirmed_email.email }}</option>
        {% endif %}
      {% endfor %}
    </select>
  </div>
  <input type="hidden" name="theme" value="{{ user.userpreference.theme }}"/>
  <button type="submit" class="button">{% trans 'Save' %}</button>
</form>

<!-- TODO: Language stuff not yet fully implemented; Esp. translations are only half-way there

<h2>{% trans 'Language' %}</h2>
<form action="{% url 'set_language' %}" method="post">{% csrf_token %}
  <div class="form-group">
    {% get_current_language as LANGUAGE_CODE %}
      {% get_available_languages as LANGUAGES %}
      {% get_language_info_list for LANGUAGES as languages %}
      {% for language in languages %}
        <div class="radio">
          <input type="radio" name="language" value="{{ language.code }}" id="language-{{ language.code }}"
            {% if language.code == LANGUAGE_CODE %}checked{% endif %}>
          <label for="language-{{ language.code }}">{{ language.name_local }}</label>
        </div>
      {% endfor %}
  </div>
  <br/>
  <button type="submit" class="button">{% trans 'Save' %}</button>
</form>

-->

<div style="height:100px"></div>

<!-- <p><a href="{% url 'export' %}" class="button">{% trans 'Export your data' %}</a></p> -->

<!-- TODO: Better coloring of the button -->
<p><a href="{% url 'delete' %}" class="button" style="background:red; color:white;">{% trans 'Permanently delete your account' %}</a></p>
<div style="height:2rem"></div>
{% endblock content %}

ivatar/ivataraccount/templates/upload_libravatar_export.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Upload an export from libravatar' %} - ivatar{% endblock title %}

{% block content %}
  <h1>{% trans 'Upload an export from libravatar' %}</h1>

    <form enctype="multipart/form-data" method="post">
{% csrf_token %}
<div class="form-group">
<label for="id_export_file">{% trans 'Export file' %}</label>
<span class="button" style="display:flex;width:120px;padding:0;height:36px;position:relative;align-items:center">
<input type="file" name="export_file" required id="id_export_file"/>
<label for="id_export_file">{% trans 'Select File' %}</label>
</span>
</div>
<div class="form-group">
<div class="checkbox">
<input type="checkbox" name="not_porn" checked required id="id_not_porn">
<label for="id_not_porn">{% trans 'suitable for all ages (i.e. no offensive content)' %}</label>
</div>
</div>
<div class="form-group">
<div class="checkbox">
<input type="checkbox" name="can_distribute" checked required id="id_can_distribute">
<label for="id_can_distribute">{% trans 'can be freely copied' %}</label>
</div>
</div>
        <button type="submit" class="button">{% trans 'Upload' %}</button>
    </form>
<div style="height:40px"></div>
{% endblock content %}

ivatar/ivataraccount/templates/upload_photo.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Upload a new photo' %}{% endblock title %}

{% block header %}<link rel="prefetch" href="{% static 'css/jcrop.css' %}">
<link rel="prefetch" href="{% static '/js/jcrop.js' %}">{% endblock header %}

{% block content %}
  <h1>{% trans 'Upload a new photo' %}</h1>

  <form enctype="multipart/form-data" action="{% url 'upload_photo' %}" method="post">{% csrf_token %}
    {% if email %}<input type="hidden" name="email" value="{{ email }}">{% endif %}
    {% if openid %}<input type="hidden" name="openid" value="{{ openid }}">{% endif %}

{% if form.photo.errors %}
<div class="alert alert-danger" role="alert">{{ form.photo.errors }}</div>
{% endif %}
<div class="form-group">
<label for="id_photo">{% trans 'Photo' %}:</label>
<span class="button uploadbtn" style="display:flex;width:14rem;padding:0;height:36px;position:relative;align-items:center">
<input type="file" name="photo" required id="id_photo" accept="image/*" style="opacity:0;width:100%;height:100%;float:left">
<label for="id_photo">{% trans 'Select Photo' %}</label>
</span>
</div>
    {% blocktrans with max_file_size|filesizeformat as max_size %}Maximum file size of {{ max_size }}.{% endblocktrans %}</p>

<div class="form-group">
<div class="checkbox">
<input type="checkbox" name="not_porn" checked required id="id_not_porn">
<label for="id_not_porn"><b>{% trans 'required' %}</b>; {% trans 'suitable for all ages (i.e. no offensive content)' %}</label>
</div>
</div>
<div class="form-group">
<div class="checkbox">
<input type="checkbox" name="can_distribute" checked required id="id_can_distribute">
<label for="id_can_distribute"><b>{% trans 'required' %}</b>; {% trans 'can be freely copied' %}</label>
</div>
</div>
      <button type="submit" class="button">{% trans 'Upload' %}</button>
  </form>
<div style="height:40px"></div>
{% endblock content %}